diff --git a/test/simpleupdatetests.py b/test/simpleupdatetests.py
index 6177fb1..ba65e55 100644
--- a/test/simpleupdatetests.py
+++ b/test/simpleupdatetests.py
@@ -990,3 +990,243 @@ class SimpleUpdateTests(OperationsTests):
         # Nothing to do...
         self.assert_(res==0, msg)
 
+    def testUpdateReqFail_1(self):
+        foo11 = FakePackage('foo', '1', '1', '0', 'i386')
+        foo11.addRequires('bar', 'EQ', ('0', '1', '1'))
+        foo12 = FakePackage('foo', '1', '2', '0', 'i386')
+        foo12.addRequires('bar', 'EQ', ('0', '1', '1'))
+
+        bar11 = FakePackage('bar', '1', '1', '0', 'i386')
+        bar12 = FakePackage('bar', '1', '2', '0', 'i386')
+
+        res, msg = self.runOperation(['update', 'bar'],
+                                     [foo11, bar11],
+                                     [foo11, foo12, bar11, bar12])
+        # Should fail...
+        self.assert_(res=='err', msg)
+
+    def testUpdateReqFail_2(self):
+        foo11 = FakePackage('foo', '1', '1', '0', 'i386')
+        foo11.addRequires('bar', 'EQ', ('0', '1', '1'))
+        foo12 = FakePackage('foo', '1', '2', '0', 'i386')
+        foo12.addRequires('bar', 'LE', ('0', '1', '1'))
+
+        bar11 = FakePackage('bar', '1', '1', '0', 'i386')
+        bar12 = FakePackage('bar', '1', '2', '0', 'i386')
+
+        res, msg = self.runOperation(['update', 'bar'],
+                                     [foo11, bar11],
+                                     [foo11, foo12, bar11, bar12])
+        # Should fail...
+        self.assert_(res=='err', msg)
+
+    def testUpdateReqFail_3(self):
+        foo11 = FakePackage('foo', '1', '1', '0', 'i386')
+        foo11.addRequires('bar', 'EQ', ('0', '1', '1'))
+        foo12 = FakePackage('foo', '1', '2', '0', 'i386')
+        foo12.addRequires('bar', 'EQ', ('0', '1', '1'))
+
+        bar11 = FakePackage('bar', '1', '1', '0', 'i386')
+        bar12 = FakePackage('bar', '1', '2', '0', 'i386')
+
+        cbar11 = FakePackage('compat-bar', '1', '1', '0', 'i386')
+        cbar11.addProvides('bar', 'EQ', ('0', '1', '1'))
+
+        res, msg = self.runOperation(['update', 'bar'],
+                                     [foo11, bar11],
+                                     [foo11, foo12, bar11, bar12, cbar11])
+        self.assert_(res=='ok', msg)
+        # Ideal:
+        # self.assertResult((foo11, bar12, cbar11))
+        self.assertResult((foo12, bar12, cbar11))
+
+    def testUpdateReqFail_4(self):
+        foo11 = FakePackage('foo', '1', '1', '0', 'i386')
+        foo11.addRequires('bar', 'EQ', ('0', '1', '1'))
+        foo12 = FakePackage('foo', '1', '2', '0', 'i386')
+        foo12.addRequires('bar', 'LE', ('0', '1', '1'))
+
+        bar11 = FakePackage('bar', '1', '1', '0', 'i386')
+        bar12 = FakePackage('bar', '1', '2', '0', 'i386')
+
+        cbar11 = FakePackage('compat-bar', '1', '1', '0', 'i386')
+        cbar11.addProvides('bar', 'EQ', ('0', '1', '1'))
+
+        res, msg = self.runOperation(['update', 'bar'],
+                                     [foo11, bar11],
+                                     [foo11, foo12, bar11, bar12, cbar11])
+        self.assert_(res=='ok', msg)
+        # Ideal:
+        # self.assertResult((foo11, bar12, cbar11))
+        self.assertResult((foo12, bar12, cbar11))
+
+    def testInstallOtherArch1(self):
+        #  Installing something with dep. on newer version should upgrade older
+        # version with other arch.
+        # Eg. BZ 791326
+        pax1 = FakePackage('inst', '1', '1', '0', 'x86_64')
+        pai1 = FakePackage('inst', '1', '1', '0', 'i686')
+        pax2 = FakePackage('inst', '2', '1', '0', 'x86_64')
+        pax2.addProvides('foo-x', 'EQ', ('0', '2', '1'))
+        pai2 = FakePackage('inst', '2', '1', '0', 'i686')
+        pai2.addProvides('foo-i', 'EQ', ('0', '2', '1'))
+
+        pa2 = FakePackage('bar', '1', '1', '0', 'i386')
+        pa2.addRequires('foo-i', 'EQ', ('0', '2', '1'))
+
+        res, msg = self.runOperation(['install', 'bar'],
+                                     [pax1],
+                                     [pax1, pai1, pax2, pai2, pa2])
+        self.assert_(res=='ok', msg)
+        self.assertResult((pax2, pai2, pa2))
+
+    def testUpdateForDeps0(self):
+        foo11 = FakePackage('foo', '1', '1', '0', 'i386')
+        foo11.addRequires('bar', 'EQ', ('0', '1', '1'))
+
+        foo12 = FakePackage('foo', '1', '2', '0', 'i386')
+        foo12.addRequires('bar', 'EQ', ('0', '1', '2'))
+
+        bar11 = FakePackage('bar', '1', '1', '0', 'i386')
+        bar11.yumdb_info.reason = 'dep'
+        bar12 = FakePackage('bar', '1', '2', '0', 'i386')
+
+        res, msg = self.runOperation(['install', 'foo', 'bar'], [foo11, bar11], [foo12, bar12])
+
+        self.assert_(res=='ok', msg)
+        self.assertResult((foo12, bar12))
+
+        self.tsInfo.makelists()
+        self.assertEquals([], self.tsInfo.depupdated)
+
+    def _pkg2txmbr(self, pkg):
+        for txmbr in self.tsInfo.getMembers(pkg.pkgtup):
+            return txmbr
+        return None
+
+    def _testUpdateForDeps_setup(self):
+        foo11 = FakePackage('foo', '1', '1', '0', 'i386')
+        foo11.addRequires('bar', 'EQ', ('0', '1', '1'))
+
+        foo12 = FakePackage('foo', '1', '2', '0', 'i386')
+        foo12.addRequires('bar', 'EQ', ('0', '1', '2'))
+
+        bar11 = FakePackage('bar', '1', '1', '0', 'i386')
+        bar11.addRequires('foo', 'EQ', ('0', '1', '1'))
+
+        bar12 = FakePackage('bar', '1', '2', '0', 'i386')
+        bar12.addRequires('foo', 'EQ', ('0', '1', '2'))
+
+        return foo11, foo12, bar11, bar12
+
+    def testUpdateForDeps_install_all1(self):
+        foo11, foo12, bar11, bar12 = self._testUpdateForDeps_setup()
+
+        res, msg = self.runOperation(['install', 'foo', 'bar'], [foo11, bar11], [foo12, bar12])
+
+        self.assert_(res=='ok', msg)
+        self.assertResult((foo12, bar12))
+
+        self.tsInfo.makelists()
+        self.assertEquals([], self.tsInfo.depupdated)
+
+    def testUpdateForDeps_upgrade_all2(self):
+        foo11, foo12, bar11, bar12 = self._testUpdateForDeps_setup()
+
+        res, msg = self.runOperation(['upgrade', 'foo', 'bar'], [foo11, bar11], [foo12, bar12])
+
+        self.assert_(res=='ok', msg)
+        self.assertResult((foo12, bar12))
+
+        self.assert_(self._pkg2txmbr(bar12).reason == 'user')
+
+        self.tsInfo.makelists()
+        self.assertEquals([], self.tsInfo.depupdated)
+
+    def testUpdateForDeps_upgrade_all3(self):
+        foo11, foo12, bar11, bar12 = self._testUpdateForDeps_setup()
+        bar11.yumdb_info.reason = 'dep'
+
+        res, msg = self.runOperation(['upgrade', 'foo', 'bar'], [foo11, bar11], [foo12, bar12])
+
+        self.assert_(res=='ok', msg)
+        self.assertResult((foo12, bar12))
+
+        self.assert_(self._pkg2txmbr(bar12).reason == 'dep')
+
+        self.tsInfo.makelists()
+        self.assertEquals([], self.tsInfo.depupdated)
+
+    def testUpdateForDeps_upgrade_foo4(self):
+        foo11, foo12, bar11, bar12 = self._testUpdateForDeps_setup()
+        foo11.yumdb_info.reason = 'user'
+        bar11.yumdb_info.reason = 'dep'
+
+        res, msg = self.runOperation(['upgrade', 'foo'], [foo11, bar11], [foo12, bar12])
+
+        self.assert_(res=='ok', msg)
+        self.assertResult((foo12, bar12))
+
+        print foo12.yumdb_info.reason
+        self.assert_(self._pkg2txmbr(foo12).reason == 'user')
+        self.assert_(self._pkg2txmbr(bar12).reason == 'dep')
+
+        self.tsInfo.makelists()
+        self.assertEquals([bar12], self.tsInfo.depupdated)
+
+    def testUpdateForDeps_upgrade_bar5(self):
+        foo11, foo12, bar11, bar12 = self._testUpdateForDeps_setup()
+        foo11.yumdb_info.reason = 'user'
+        bar11.yumdb_info.reason = 'dep'
+
+        res, msg = self.runOperation(['upgrade', 'bar'], [foo11, bar11], [foo12, bar12])
+
+        self.assert_(res=='ok', msg)
+        self.assertResult((foo12, bar12))
+
+        self.assert_(self._pkg2txmbr(foo12).reason == 'user')
+        self.assert_(self._pkg2txmbr(bar12).reason == 'dep')
+
+        self.tsInfo.makelists()
+        self.assertEquals([foo12], self.tsInfo.depupdated)
+
+    def testUpdateForDeps_install_foo6(self):
+        foo11, foo12, bar11, bar12 = self._testUpdateForDeps_setup()
+
+        res, msg = self.runOperation(['install', 'foo'], [], [foo11, bar11, foo12, bar12])
+
+        self.assert_(res=='ok', msg)
+        self.assertResult((foo12, bar12))
+
+        self.assert_(self._pkg2txmbr(foo12).reason == 'user')
+        self.assert_(self._pkg2txmbr(bar12).reason == 'dep')
+
+        self.tsInfo.makelists()
+        self.assertEquals([bar12], self.tsInfo.depinstalled)
+
+    def testUpdateForDeps_install_bar7(self):
+        foo11, foo12, bar11, bar12 = self._testUpdateForDeps_setup()
+
+        res, msg = self.runOperation(['install', 'bar'], [], [foo11, bar11, foo12, bar12])
+
+        self.assert_(res=='ok', msg)
+        self.assertResult((foo12, bar12))
+
+        self.assert_(self._pkg2txmbr(foo12).reason == 'dep')
+        self.assert_(self._pkg2txmbr(bar12).reason == 'user')
+
+        self.tsInfo.makelists()
+        self.assertEquals([foo12], self.tsInfo.depinstalled)
+
+    def testUpdateForDeps_downgrade_all8(self):
+        foo11, foo12, bar11, bar12 = self._testUpdateForDeps_setup()
+        foo12.yumdb_info.reason = 'user'
+        bar12.yumdb_info.reason = 'blahg'
+
+        res, msg = self.runOperation(['downgrade', 'foo', 'bar'], [foo12, bar12], [foo11, bar11, foo12, bar12])
+
+        self.assert_(res=='ok', msg)
+        self.assertResult((foo11, bar11))
+
+        self.assert_(self._pkg2txmbr(foo11).reason == 'user')
+        self.assert_(self._pkg2txmbr(bar11).reason == 'blahg')
diff --git a/test/skipbroken-tests.py b/test/skipbroken-tests.py
index 812785a..e2abc4c 100644
--- a/test/skipbroken-tests.py
+++ b/test/skipbroken-tests.py
@@ -26,7 +26,7 @@ class SkipBrokenTests(DepsolveTests):
 
     def _pkgstr_to_nevra(self, pkg_str):
         '''
-        Get a nevra from from a epoch:name-version-release.arch string
+        Get a nevra from from an epoch:name-version-release.arch string
         @param pkg_str: package string
         '''
         res = REGEX_PKG.search(pkg_str)
@@ -40,7 +40,7 @@ class SkipBrokenTests(DepsolveTests):
 
     def repoString(self, pkg_str):
         ''' 
-        Add an available package from a epoch:name-version-release.arch string
+        Add an available package from an epoch:name-version-release.arch string
         '''
         (n,e,v,r,a) = self._pkgstr_to_nevra(pkg_str)
         return self.repoPackage(n,v,r,e,a)   
@@ -48,7 +48,7 @@ class SkipBrokenTests(DepsolveTests):
             
     def instString(self, pkg_str):
         ''' 
-        Add an installed package from a epoch:name-version-release.arch string
+        Add an installed package from an epoch:name-version-release.arch string
         '''
         (n,e,v,r,a) = self._pkgstr_to_nevra(pkg_str)
         return self.instPackage(n,v,r,e,a)   
@@ -81,7 +81,7 @@ class SkipBrokenTests(DepsolveTests):
         self.assertResult([])
 
     def testDepWithMissingReqSkip(self):
-        ''' install is skipped, beacuse dep is missing req.  
+        ''' install is skipped, because dep is missing req.  
         foo + foobar is skipped because barfoo is not provided
         bar stays in the transaction
         '''
@@ -119,7 +119,7 @@ class SkipBrokenTests(DepsolveTests):
     def testUpdateRequireOld(self):
         '''update with missing req. is skipped
         The foo-1.0 -> foo-2.0 update fails, because foo-tools-2.0 need by foo-2.0
-        is not provided, the update should be skipped and result in a empty transaction
+        is not provided, the update should be skipped and result in an empty transaction
         '''
         po1 = self.instPackage('foo', '1')
         po1.addRequires('foo-tools', 'EQ', ('0', '1', '0'))
@@ -219,7 +219,7 @@ class SkipBrokenTests(DepsolveTests):
         self.assertResult([ipo, po1])
 
     def testConflictWithInstalledButUpdateExist(self):
-        ''' update fails, because conflict cant be fixed. (req. loop)
+        ''' update fails, because conflict can't be fixed. (req. loop)
         foo 1.0 -> 2.0 update fails, because foo-2.0 conflict with bar-1.0
         bar-1.0 is update to bar-2.0, to solve the conflict but bar-2.0 need foo-1.0
         so the foo & bar updates get skipped and the transaction is empty
@@ -240,7 +240,7 @@ class SkipBrokenTests(DepsolveTests):
         self.assertResult([po1,ipo])
 
     def testConflictWithInstalledButUpdateExist2(self):
-        '''update fails, because conflict cant be fixed. (missing req.)
+        '''update fails, because conflict can't be fixed. (missing req.)
         foo 1.0 -> 2.0 update fails, because foo-2.0 conflict with bar-1.0
         bar-1.0 is update to bar-2.0, to solve the conflict but bar-2.0 need poo-1.0
         there is not provided
@@ -809,7 +809,55 @@ class SkipBrokenTests(DepsolveTests):
         members.append(u1)
         self.assertEquals('ok', *self.resolveCode(skip=True))
         self.assertResult(members)
+
+    def test_skipbroken_004_deps_1(self):
+        ''' 
+        this tries to test that when we have two things depending on Y, and we
+        remove one of them we do not want to remove Y. bz#905899.
+        '''
+        members = []
+        ux0 = self.repoString('1:bar-1.0.0-1.i686')
+        members.append(ux0)
+
+        ux1 = self.repoString('1:foo1-1.0.0-1.i686')
+        ux1.addRequires('bar')
+        ux1.addRequires('blah')
+
+        ux2 = self.repoString('1:foo2-1.0.0-1.i686')
+        ux2.addRequires('bar')
+        members.append(ux2)
+
+        self.tsInfo.addInstall(ux1)
+        self.tsInfo.addInstall(ux2)
+
+        self.assertEquals('ok', *self.resolveCode(skip=True))
+        self.assertResult(members)
     
+    def test_skipbroken_004_deps_2(self):
+        ''' 
+        this tries to test that when we have two things depending on Y, and we
+        remove both then we do want to remove Y again. bz#905899.
+        '''
+        members = []
+        ux0 = self.repoString('1:bar-1.0.0-1.i686')
+
+        ux0 = self.repoString('1:zoom-1.0.0-1.i686')
+        members.append(ux0)
+
+        ux1 = self.repoString('1:foo1-1.0.0-1.i686')
+        ux1.addRequires('bar')
+        ux1.addRequires('blah')
+
+        ux2 = self.repoString('1:foo2-1.0.0-1.i686')
+        ux2.addRequires('bar')
+        ux2.addRequires('baz')
+
+        self.tsInfo.addInstall(ux0)
+        self.tsInfo.addInstall(ux1)
+        self.tsInfo.addInstall(ux2)
+
+        self.assertEquals('ok', *self.resolveCode(skip=True))
+        self.assertResult(members)
     
     def resolveCode(self,skip = False):
         solver = YumBase()
diff --git a/test/testbase.py b/test/testbase.py
index d0f22be..e2a1d05 100644
--- a/test/testbase.py
+++ b/test/testbase.py
@@ -55,6 +55,18 @@ class FakeConf(object):
         self.protected_packages = []
         self.protected_multilib = False
         self.clean_requirements_on_remove = True
+        self.upgrade_requirements_on_install = False
+        self.recheck_installed_requires = False
+        self.group_command = 'compat'
+        self.repopkgsremove_leaf_only = False
+        self.remove_leaf_only = False
+        self.config_file_path = '/dev/null'
+        self.config_file_age = 0
+        self.yumvar = {}
+        self.reposdir = '/tmp/XXXX'
+        self.diskspacecheck = True
+        self.depsolve_loop_limit = 10
+        self.override_install_langs = ''
 
 class FakeSack:
     """ Fake PackageSack to use with FakeRepository"""
@@ -138,6 +150,7 @@ class FakePackage(packages.YumAvailablePackage):
         self.yumdb_info = FakeYumDBInfo()
 
         self.prco['provides'].append((name, 'EQ', (epoch, version, release)))
+        self.prco['strong_requires'] = []
 
         # Just a unique integer
         self.id = self.__hash__()
@@ -149,6 +162,7 @@ class FakePackage(packages.YumAvailablePackage):
         self.prco['provides'].append((name, flag, evr))
     def addRequires(self, name, flag=None, evr=(None, None, None)):
         self.prco['requires'].append((name, flag, evr))
+        self.prco['strong_requires'].append((name, flag, evr))
     def addRequiresPkg(self, pkg):
         self.required_pkgs.append(pkg)
     def addRequiringPkg(self, pkg):
@@ -310,6 +324,12 @@ class FakeRpmDb(packageSack.PackageSack):
             if len(pkg.conflicts):
                 ret.append(pkg)
         return ret
+    def returnObsoletePackages(self):
+        ret = []
+        for pkg in self.returnPackages():
+            if len(pkg.obsoletes):
+                ret.append(pkg)
+        return ret
     def fileRequiresData(self):
         installedFileRequires = {}
         installedUnresolvedFileRequires = set()
@@ -344,6 +364,8 @@ class FakeRpmDb(packageSack.PackageSack):
         return
     def transactionCacheConflictPackages(self, pkgs):
         return
+    def transactionCacheObsoletePackages(self, pkgs):
+        return
     def transactionResultVersion(self, rpmdbv):
         return
     def transactionReset(self):
@@ -381,7 +403,7 @@ class FakeRpmDb(packageSack.PackageSack):
 #######################################################################
 
 class DepsolveTests(_DepsolveTestsBase):
-    """Run depsolver on an manually  set up transaction.
+    """Run depsolver on a manually set up transaction.
     You can add pkgs to self.rpmdb or self.tsInfo. See
     yum/transactioninfo.py for details.
     A typical test case looks like:
diff --git a/test/yum-leak-test.py b/test/yum-leak-test.py
index 760b770..dd64483 100755
--- a/test/yum-leak-test.py
+++ b/test/yum-leak-test.py
@@ -33,6 +33,13 @@ def _leak_tst_yb():
     yb.repos.setCacheDir(yum.misc.getCacheDir())
     yb.rpmdb.returnPackages()
     yb.pkgSack.returnPackages()
+    yb.tsInfo
+    yb.ts
+    yb.up
+    yb.comps
+    yb.history
+    yb.igroups
+    yb.pkgtags
     out_mem(os.getpid())
     time.sleep(4)
 
diff --git a/test/yum-pylintrc b/test/yum-pylintrc
index fa3e57c..d0cf2a6 100644
--- a/test/yum-pylintrc
+++ b/test/yum-pylintrc
@@ -1,11 +1,3 @@
-# lint Python modules using external checkers.
-# 
-# This is the main checker controling the other ones and the reports
-# generation. It is itself both a raw checker and an astng checker in order
-# to:
-# * handle message activation / deactivation at the module level
-# * handle some basic but necessary stats'data (number of classes, methods...)
-# 
 [MASTER]
 
 # Specify a configuration file.
@@ -13,7 +5,7 @@
 
 # Python code to execute, usually for sys.path manipulation such as
 # pygtk.require().
-#init-hook=="execfile('test/pylint-setup.py')"
+#init-hook=
 
 # Profiled execution.
 profile=no
@@ -25,9 +17,6 @@ ignore=CVS
 # Pickle collected data for later comparisons.
 persistent=yes
 
-# Set the cache size for astng objects.
-cache-size=500
-
 # List of plugins (as comma separated values of python modules names) to load,
 # usually to register additional checkers.
 load-plugins=
@@ -35,25 +24,16 @@ load-plugins=
 
 [MESSAGES CONTROL]
 
-# Enable only checker(s) with the given id(s). This option conflicts with the
-# disable-checker option
-#enable-checker=
-
-# Enable all checker(s) except those with the given id(s). This option
-# conflicts with the enable-checker option
-#disable-checker=
-
-# Enable all messages in the listed categories.
-#enable-msg-cat=
-
-# Disable all messages in the listed categories.
-disable-msg-cat=C,R
+# Enable the message, report, category or checker with the given id(s). You can
+# either give multiple identifier separated by comma (,) or put this option
+# multiple time.
+#enable=
 
-# Enable the message(s) with the given id(s).
-#enable-msg=
+# Disable the message, report, category or checker with the given id(s). You
+# can either give multiple identifier separated by comma (,) or put this option
+# multiple time.
 
-# Disable the message(s) with the given id(s).
-# E1101: *%s %r has no %r member* (The init-hook for do sys.path manipulation don't, so we cant find the utils module)
+# E1101: *%s %r has no %r member* (The init-hook for do sys.path manipulation don't, so we can't find the utils module)
 # F0401: *Unable to import %r (%s)* (See above)
 # W0704: *Except doesn't do anything* ( Except xxxxxx,e : pass is ok)
 # W0612: *Unused variable %r* ( dont care if x,y,z = f() and y,z is not used) 
@@ -83,12 +63,13 @@ disable-msg-cat=C,R
 # W0710: *Exception doesn't inherit from standard "Exception" class* (give false positives on ex. KeyboardInterrupt)
 # W0631: *Using possibly undefined loop variable %r* (Gives to many false positives)
 # E1103: *%s %r has no %r member (but some types could not be inferred)*
-disable-msg=E1101,F0401,W0704,W0612,W0212,W0613,W0602,W0511,W0401,W0614,W0232,W0201,W0603,W0621,W0142,W0102,W0105,W0702,W0231,E0202,W0622,W0403,W0223,W0104,W1001,W0221,W0703,W0710,W0631,E1103
+
+disable=C,R,I,E1101,F0401,W0704,W0612,W0212,W0613,W0602,W0511,W0401,W0614,W0232,W0201,W0603,W0621,W0142,W0102,W0105,W0702,W0231,E0202,W0622,W0403,W0223,W0104,W1001,W0221,W0703,W0710,W0631,E1103
 
 
 [REPORTS]
 
-# set the output format. Available formats are text, parseable, colorized, msvs
+# Set the output format. Available formats are text, parseable, colorized, msvs
 # (visual studio) and html
 output-format=colorized
 
@@ -100,12 +81,12 @@ include-ids=yes
 # written in a file name "pylint_global.[txt|html]".
 files-output=no
 
-# Tells wether to display a full report or only the messages
+# Tells whether to display a full report or only the messages
 reports=yes
 
 # Python expression which should return a note less than 10 (10 is the highest
-# note).You have access to the variables errors warning, statement which
-# respectivly contain the number of errors / warnings messages and the total
+# note). You have access to the variables errors warning, statement which
+# respectively contain the number of errors / warnings messages and the total
 # number of statements analyzed. This is used by the global evaluation report
 # (R0004).
 evaluation=10.0 - ((float(5 * error + warning + refactor + convention) / statement) * 10)
@@ -114,79 +95,94 @@ evaluation=10.0 - ((float(5 * error + warning + refactor + convention) / stateme
 # evaluation report (R0004).
 comment=no
 
-# Enable the report(s) with the given id(s).
-#enable-report=
 
-# Disable the report(s) with the given id(s).
-#disable-report=
+[MISCELLANEOUS]
+
+# List of note tags to take in consideration, separated by a comma.
+notes=FIXME,XXX,TODO
+
+
+[TYPECHECK]
+
+# Tells whether missing members accessed in mixin class should be ignored. A
+# mixin class is detected if its name ends with "mixin" (case insensitive).
+ignore-mixin-members=yes
+
+# List of classes names for which member attributes should not be checked
+# (useful for classes with attributes dynamically set).
+ignored-classes=SQLObject
+
+# When zope mode is activated, add a predefined set of Zope acquired attributes
+# to generated-members.
+zope=no
+
+# List of members which are set dynamically and missed by pylint inference
+# system, and so shouldn't trigger E0201 when accessed.
+generated-members=REQUEST,acl_users,aq_parent
 
 
-# checks for :
-# * doc strings
-# * modules / classes / functions / methods / arguments / variables name
-# * number of arguments, local variables, branchs, returns and statements in
-# functions, methods
-# * required module attributes
-# * dangerous default values as arguments
-# * redefinition of function / method / class
-# * uses of the global statement
-# 
 [BASIC]
 
 # Required attributes for module, separated by a comma
 required-attributes=
 
-# Regular expression which should only match functions or classes name which do
-# not require a docstring
-no-docstring-rgx=__.*__
+# List of builtins function names that should not be used, separated by a comma
+bad-functions=input
 
 # Regular expression which should only match correct module names
-module-rgx=(([a-z_][a-z0-9_\-]*)|([A-Z][a-zA-Z0-9]+))$
+module-rgx=(([a-z_][a-z0-9_]*)|([A-Z][a-zA-Z0-9]+))$
 
 # Regular expression which should only match correct module level names
-const-rgx=(([A-Z_a-z][A-Z1-9_a-z]*)|(__.*__))$
+const-rgx=(([A-Z_][A-Z0-9_]*)|(__.*__))$
 
 # Regular expression which should only match correct class names
 class-rgx=[A-Z_][a-zA-Z0-9]+$
 
 # Regular expression which should only match correct function names
-function-rgx=[a-z_][a-z0-9_A-Z]{2,30}$
+function-rgx=[a-z_][a-z0-9_]{2,30}$
 
 # Regular expression which should only match correct method names
-method-rgx=[a-z_][a-z0-9_A-Z]{2,30}$
+method-rgx=[a-z_][a-z0-9_]{2,30}$
 
 # Regular expression which should only match correct instance attribute names
-attr-rgx=[a-z_][a-z0-9_A-Z]{2,30}$
+attr-rgx=[a-z_][a-z0-9_]{2,30}$
 
 # Regular expression which should only match correct argument names
-argument-rgx=[a-z_][a-z0-9_A-Z]{0,30}$
+argument-rgx=[a-z_][a-z0-9_]{2,30}$
 
 # Regular expression which should only match correct variable names
-variable-rgx=[a-z_][a-z0-9_A-Z]{0,30}$
+variable-rgx=[a-z_][a-z0-9_]{2,30}$
 
 # Regular expression which should only match correct list comprehension /
 # generator expression variable names
 inlinevar-rgx=[A-Za-z_][A-Za-z0-9_]*$
 
 # Good variable names which should always be accepted, separated by a comma
-good-names=i,j,k,ex,Run,_,n,e,r,v,a,po,f,m,u,h,l
+good-names=i,j,k,ex,Run,_
 
 # Bad variable names which should always be refused, separated by a comma
 bad-names=foo,bar,baz,toto,tutu,tata
 
-# List of builtins function names that should not be used, separated by a comma
-bad-functions=input
+# Regular expression which should only match functions or classes name which do
+# not require a docstring
+no-docstring-rgx=__.*__
+
+
+[SIMILARITIES]
+
+# Minimum lines number of a similarity.
+min-similarity-lines=4
+
+# Ignore comments when computing similarities.
+ignore-comments=yes
+
+# Ignore docstrings when computing similarities.
+ignore-docstrings=yes
 
 
-# checks for
-# * unused variables / imports
-# * undefined variables
-# * redefinition of variable from builtins or from an outer scope
-# * use of variable before assigment
-# 
 [VARIABLES]
 
-# Tells wether we should check for unused import in __init__ files.
+# Tells whether we should check for unused import in __init__ files.
 init-import=no
 
 # A regular expression matching names used for dummy variables (i.e. not used).
@@ -197,89 +193,67 @@ dummy-variables-rgx=_|dummy
 additional-builtins=
 
 
-# try to find bugs in the code using type inference
-# 
-[TYPECHECK]
+[FORMAT]
 
-# Tells wether missing members accessed in mixin class should be ignored. A
-# mixin class is detected if its name ends with "mixin" (case insensitive).
-ignore-mixin-members=yes
+# Maximum number of characters on a single line.
+max-line-length=80
 
-# List of classes names for which member attributes should not be checked
-# (useful for classes with attributes dynamicaly set).
-ignored-classes=SQLObject,NullTranslations
+# Maximum number of lines in a module
+max-module-lines=1000
 
-# When zope mode is activated, consider the acquired-members option to ignore
-# access to some undefined attributes.
-zope=no
+# String used as indentation unit. This is usually " " (4 spaces) or "\t" (1
+# tab).
+indent-string='    '
 
-# List of members which are usually get through zope's acquisition mecanism and
-# so shouldn't trigger E0201 when accessed (need zope=yes to be considered).
-acquired-members=REQUEST,acl_users,aq_parent
+
+[CLASSES]
+
+# List of interface methods to ignore, separated by a comma. This is used for
+# instance to not check methods defines in Zope's Interface base class.
+ignore-iface-methods=isImplementedBy,deferred,extends,names,namesAndDescriptions,queryDescriptionFor,getBases,getDescriptionFor,getDoc,getName,getTaggedValue,getTaggedValueTags,isEqualOrExtendedBy,setTaggedValue,isImplementedByInstancesOf,adaptWith,is_implemented_by
+
+# List of method names used to declare (i.e. assign) instance attributes.
+defining-attr-methods=__init__,__new__,setUp
 
 
-# checks for
-# * external modules dependencies
-# * relative / wildcard imports
-# * cyclic imports
-# * uses of deprecated modules
-# 
 [IMPORTS]
 
 # Deprecated modules which should not be used, separated by a comma
 deprecated-modules=regsub,TERMIOS,Bastion,rexec
 
 # Create a graph of every (i.e. internal and external) dependencies in the
-# given file (report R0402 must not be disabled)
+# given file (report RP0402 must not be disabled)
 import-graph=
 
-# Create a graph of external dependencies in the given file (report R0402 must
+# Create a graph of external dependencies in the given file (report RP0402 must
 # not be disabled)
 ext-import-graph=
 
-# Create a graph of internal dependencies in the given file (report R0402 must
+# Create a graph of internal dependencies in the given file (report RP0402 must
 # not be disabled)
 int-import-graph=
 
 
-# checks for :
-# * methods without self as first argument
-# * overridden methods signature
-# * access only to existant members via self
-# * attributes not defined in the __init__ method
-# * supported interfaces implementation
-# * unreachable code
-# 
-[CLASSES]
-
-# List of interface methods to ignore, separated by a comma. This is used for
-# instance to not check methods defines in Zope's Interface base class.
-ignore-iface-methods=interrupt_callback
-
-# List of method names used to declare (i.e. assign) instance attributes.
-defining-attr-methods=__init__,__new__,setUp
-
-
-# checks for sign of poor/misdesign:
-# * number of methods, attributes, local variables...
-# * size, complexity of functions, methods
-# 
 [DESIGN]
 
 # Maximum number of arguments for function / method
 max-args=5
 
+# Argument names that match this expression will be ignored. Default to name
+# with leading underscore
+ignored-argument-names=_.*
+
 # Maximum number of locals for function / method body
-max-locals=30
+max-locals=15
 
 # Maximum number of return / yield for function / method body
-max-returns=10
+max-returns=6
 
 # Maximum number of branch for function / method body
-max-branchs=25
+max-branchs=12
 
 # Maximum number of statements in function / method body
-max-statements=100
+max-statements=50
 
 # Maximum number of parents for a class (see R0901).
 max-parents=7
@@ -291,49 +265,4 @@ max-attributes=7
 min-public-methods=2
 
 # Maximum number of public methods for a class (see R0904).
-max-public-methods=100
-
-
-# checks for :
-# * unauthorized constructions
-# * strict indentation
-# * line length
-# * use of <> instead of !=
-# 
-[FORMAT]
-
-# Maximum number of characters on a single line.
-max-line-length=80
-
-# Maximum number of lines in a module
-max-module-lines=1000
-
-# String used as indentation unit. This is usually " " (4 spaces) or "\t" (1
-# tab).
-indent-string='    '
-
-
-# checks for similarities and duplicated code. This computation may be
-# memory / CPU intensive, so you should disable it if you experiments some
-# problems.
-# 
-[SIMILARITIES]
-
-# Minimum lines number of a similarity.
-min-similarity-lines=4
-
-# Ignore comments when computing similarities.
-ignore-comments=yes
-
-# Ignore docstrings when computing similarities.
-ignore-docstrings=yes
-
-
-# checks for:
-# * warning notes in the code like FIXME, XXX
-# * PEP 263: source code with non ascii character but no encoding declaration
-# 
-[MISCELLANEOUS]
-
-# List of note tags to take in consideration, separated by a comma.
-notes=FIXME,XXX,TODO
+max-public-methods=20
